stock wS_ReloadTags()
{
	decl Handle:hTrie;

	TAG_START[0]			= 0;
	TAG_END[0]				= 0;

	if (!g_hTagAr)
	{
		g_hTagAr			= CreateArray(TAG_LENGTH);
		g_hTagKeyAr			= CreateArray(TAG_LENGTH);
		g_hTagVipGroupAr	= CreateArray(1);
	}
	else
	{
		while (--g_iTagCount > -1)
		{
			if ((hTrie = Handle:GetArrayCell(g_hTagVipGroupAr, g_iTagCount)))
				CloseHandle(hTrie);
		}

		ClearArray(g_hTagAr);
		ClearArray(g_hTagKeyAr);
		ClearArray(g_hTagVipGroupAr);
	}

	g_iTagCount = 0;

	/////
	new Handle:kv = CreateKeyValues("tags");
	if (FileToKeyValues(kv,	"cfg/vip/modules/chat/tags.txt"))
	{
		KvGetString(kv,	"TAG_START",	TAG_START,		sizeof(TAG_START),		"");
		KvGetString(kv,	"TAG_END",		TAG_END,		sizeof(TAG_END),		"");

		if (KvGotoFirstSubKey(kv, true))
		{
			decl String:sTagKey[TAG_LENGTH], String:sTag[TAG_LENGTH], String:info[1000], String:buffer[20][GROUP_LENGTH], x;
			do
			{
				if (KvGetSectionName(kv, sTagKey, TAG_LENGTH) && TrimString(sTagKey) && FindStringInArray(g_hTagKeyAr, sTagKey) < 0)
				{
					KvGetString(kv,		"vip_tag",		sTag,	TAG_LENGTH,	"");
					if (!sTag[0])
						continue;

					hTrie = INVALID_HANDLE;
					KvGetString(kv,		"vip_groups",	info,	sizeof(info), "");

					if (info[0] && (x = ExplodeString(info, "|", buffer, sizeof(buffer), sizeof(buffer[]))) > 0)
					{
						while (--x > -1)
						{
							if (TrimString(buffer[x]) && VIP_IsValidGroup(buffer[x]))
							{
								if (hTrie == INVALID_HANDLE) hTrie = CreateTrie();
								SetTrieValue(hTrie, buffer[x], 1);
							}
						}
					}

					PushArrayString(g_hTagAr,			sTag);
					PushArrayString(g_hTagKeyAr, 		sTagKey);
					PushArrayCell(g_hTagVipGroupAr,		hTrie);
					g_iTagCount++;
				}
			}
			while (KvGotoNextKey(kv, true));
		}
	}
	CloseHandle(kv);
	/////

	if (g_iTagCount < 1)
	{
		PushArrayString(g_hTagAr,		"VIP");
		PushArrayString(g_hTagKeyAr,	"vip");
		PushArrayCell(g_hTagVipGroupAr,	INVALID_HANDLE);
		g_iTagCount++;
	}

	if (!TAG_START[0] && VIP_GetServerType() == 1)
	{
		strcopy(TAG_START,	sizeof(TAG_START),	"★ ");
		strcopy(TAG_END,	sizeof(TAG_END),	" ★ ");
	}
}