stock wS_ReloadColors()
{
	decl Handle:hTrie;

	if (g_hColorNameAr == INVALID_HANDLE)
	{
		g_hColorNameAr				= CreateArray(COLOR_NAME_LENGTH);
		g_hColorNameKeyAr			= CreateArray(COLOR_NAME_LENGTH);
		g_hColorStringAr			= CreateArray(sizeof(g_sMyColorString[][]));
		g_hColorVipGroupAr			= CreateArray(1);
	}
	else
	{
		while (--g_iColorCount > -1)
		{
			if ((hTrie = Handle:GetArrayCell(g_hColorVipGroupAr, g_iColorCount)))
				CloseHandle(hTrie);
		}

		ClearArray(g_hColorNameAr);
		ClearArray(g_hColorNameKeyAr);
		ClearArray(g_hColorStringAr);
		ClearArray(g_hColorVipGroupAr);
	}

	g_iColorCount					= 0;

	/////
	new Handle:kv					= CreateKeyValues("colors");
	if (FileToKeyValues(kv,			"cfg/vip/modules/chat/colors.txt"))
	{
		decl String:sServerType[16];
		if (g_ServerType == 1)		strcopy(sServerType, sizeof(sServerType), "CSGO");
		else if (g_ServerType == 2)	strcopy(sServerType, sizeof(sServerType), "CSS_STEAM");
		else						strcopy(sServerType, sizeof(sServerType), "CSS_v34");

		if (KvJumpToKey(kv,			sServerType,	false))
		{
			KvGetString(kv,			"TAG_START",	TAG_START,	sizeof(TAG_START),	"");
			KvGetString(kv,			"TAG_END",		TAG_END,	sizeof(TAG_END),	"");

			if (KvGotoFirstSubKey(kv, false))
			{
				decl String:sColorName[COLOR_NAME_LENGTH], String:sColorString[sizeof(g_sMyColorString[][])], String:info[1000], String:buffer[20][GROUP_LENGTH], x;
				do
				{
					if (KvGetSectionName(kv, sColorName, COLOR_NAME_LENGTH) && TrimString(sColorName))
					{
						KvGetString(kv, "",	info, sizeof(info), "");
						if (info[0] && (x = ExplodeString(info, "|", buffer, sizeof(buffer), sizeof(buffer[]))) > 0 && TrimString(buffer[0]) && FindStringInArray(g_hColorNameKeyAr, buffer[0]) < 0)
						{
							wS_GetColorString(buffer[0], sColorString, sizeof(sColorString));

							hTrie = INVALID_HANDLE;
							while (--x > 0)
							{
								if (TrimString(buffer[x]) && VIP_IsValidGroup(buffer[x]))
								{
									if (hTrie == INVALID_HANDLE) hTrie = CreateTrie();
									SetTrieValue(hTrie, buffer[x], 1);
								}
							}

							PushArrayString(g_hColorNameAr,		sColorName);
							PushArrayString(g_hColorNameKeyAr,	buffer[0]);
							PushArrayString(g_hColorStringAr,	sColorString);
							PushArrayCell(g_hColorVipGroupAr,	hTrie);

							g_iColorCount++;
						}
					}
				}
				while (KvGotoNextKey(kv, false));
			}
		}
	}
	CloseHandle(kv);
	/////

	if (g_iColorCount < 1)
	{
		PushArrayString(g_hColorNameAr,		"Light Green");
		PushArrayString(g_hColorNameKeyAr,	"{lightgreen}");
		PushArrayString(g_hColorStringAr,	g_ServerType == 1 ? "\x06" : "\x04");
		PushArrayCell(g_hColorVipGroupAr,	INVALID_HANDLE);
		g_iColorCount++;
	}
}

static wS_GetColorString(const String:s[], String:buffer[], maxlength)
{
	if (!strcmp(s, "{team}", false))
		return strcopy(buffer, maxlength, s);
	
	if (g_ServerType == 1)
	{
		// CSGO
		if (!strcmp(s, "{lightblue}",	false))		return strcopy(buffer, maxlength, "\x0B");
		if (!strcmp(s, "{darkblue}",	false))		return strcopy(buffer, maxlength, "\x0C");
		if (!strcmp(s, "{purple}",		false))		return strcopy(buffer, maxlength, "\x0E");
		if (!strcmp(s, "{darkred}",		false))		return strcopy(buffer, maxlength, "\x02");
		if (!strcmp(s, "{lightred}",	false))		return strcopy(buffer, maxlength, "\x07");
		if (!strcmp(s, "{gray}",		false))		return strcopy(buffer, maxlength, "\x08");
		if (!strcmp(s, "{orange}",		false))		return strcopy(buffer, maxlength, "\x09");
		if (!strcmp(s, "{pink}",		false))		return strcopy(buffer, maxlength, "\x03");
		if (!strcmp(s, "{yellowgreen}",	false))		return strcopy(buffer, maxlength, "\x05");
		if (!strcmp(s, "{darkgreen}",	false))		return strcopy(buffer, maxlength, "\x04");
		if (!strcmp(s, "{lightgreen}",	false))		return strcopy(buffer, maxlength, "\x06");
	}
	else
	{
		//  CSS_STEAM + CSS_v34
		if (!strcmp(s, "{lightgreen}",	false))		return strcopy(buffer, maxlength, "\x03");
		if (!strcmp(s, "{green}",		false))		return strcopy(buffer, maxlength, "\x04");

		// CSS_STEAM
		if (g_ServerType != 2)						return strcopy(buffer, maxlength, "\x01");
		if (!strcmp(s, "{darkgreen}",	false))		return strcopy(buffer, maxlength, "\x05");

		if (s[0] == '#')
			return FormatEx(buffer,		maxlength,	"\x07%s", s[1]);
	}

	return strcopy(buffer, maxlength,	"\x01");
}