public Action:SayHook(client, const String:command[], args)
{
	if (client < 1 || client > MaxClients || !g_bEnabled[client] || !g_bReady[client] || ClientGagged(client))
		return Plugin_Continue;

	if (g_bSkipMessage[client])
	{
		g_bSkipMessage[client] = false;
		return Plugin_Continue;
	}

	if (g_fChatFlood > 0.0)
	{
		decl Float:fCurrentTime;
		if (((fCurrentTime = GetGameTime()) - g_fLastChatMsgTime[client]) < g_fChatFlood)
		{
			g_fLastChatMsgTime[client] = fCurrentTime;
			return Plugin_Handled;
		}
		g_fLastChatMsgTime[client] = fCurrentTime;
	}

	decl String:message[512];
	if (GetCmdArgString(message, sizeof(message)) < 1)
		return Plugin_Continue;

	StripQuotes(message);

	/////
	if (wS_ExceptionPhrase(message))	return Plugin_Continue;
	decl String:symbol[4];
	FormatEx(symbol, sizeof(symbol),	"%c", message[0]);
	if (wS_ExceptionSymbol(symbol))		return Plugin_Continue;
	/////

	if (command[3] == '_')
	{
		decl team, String:sTeam[32];
		if ((team = GetClientTeam(client)) == 2) strcopy(sTeam, sizeof(sTeam), IsPlayerAlive(client) ? "(Terrorist) " : "*DEAD*(Terrorist) ");
		else if (team == 3) strcopy(sTeam, sizeof(sTeam), IsPlayerAlive(client) ? "(Counter-Terrorist) " : "*DEAD*(Counter-Terrorist) ");
		else strcopy(sTeam, sizeof(sTeam), "(Spectator) ");

		if (g_sMyTag[client][0] != 0x01)
			Format(message, sizeof(message), "\x03\x01%s%s%s%s\x01%s%s%N %s: %s", sTeam, TAG_START, g_sMyColorString[client][0], g_sMyTag[client], TAG_END, g_sMyColorString[client][1], client, g_sMyColorString[client][2], message);
		else
			Format(message, sizeof(message), "\x03\x01%s%s%N %s: %s", sTeam, g_sMyColorString[client][1], client, g_sMyColorString[client][2], message);

		if (g_bTeamColorUse[client])
			SendTeamColorMsg(client, team, true, message, sizeof(message));
		else
			send_msg(client, message, team);
	}
	else
	{
		if (g_sMyTag[client][0] != 0x01)
			Format(message, sizeof(message), "\x03\x01%s%s%s%s\x01%s%s%N %s: %s", IsPlayerAlive(client) ? "" : "*DEAD* ", TAG_START, g_sMyColorString[client][0], g_sMyTag[client], TAG_END, g_sMyColorString[client][1], client, g_sMyColorString[client][2], message);
		else
			Format(message, sizeof(message), "\x03\x01%s%s%N %s: %s", IsPlayerAlive(client) ? "" : "*DEAD* ", g_sMyColorString[client][1], client, g_sMyColorString[client][2], message);

		if (g_bTeamColorUse[client])
			SendTeamColorMsg(client, GetClientTeam(client), false, message, sizeof(message));
		else
			send_msg(client, message);
	}

	return Plugin_Handled;
}

static SendTeamColorMsg(client, team, bool:bMsgForTeam, String:message[], size)
{
	if (g_ServerType == 1) // csgo
	{
		if (team == 2) ReplaceString(message, size, "{team}", "\x09", false);		// {orange}    \x09 t
		else if (team == 3) ReplaceString(message, size, "{team}", "\x0B", false);	// {lightblue} \x0B ct
		else ReplaceString(message, size, "{team}", "\x02", false);					// {darkred}   \x02 spec
		send_msg(client, message, bMsgForTeam ? team : 0);
	}
	else // css
	{
		ReplaceString(message, size, "{team}", "\x03", false);
		
		new clients[MaxClients];
		new clients_count = 0;
		new bool:bAuthorAlive  = IsPlayerAlive(client);
		new bool:bCanSendToAll = g_iChatAllFlag && (GetUserFlagBits(client) & g_iChatAllFlag);
		
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && (!bMsgForTeam || GetClientTeam(i) == team) && (bCanSendToAll || CanSendMsg(bAuthorAlive, i)))
				clients[clients_count++] = i;
		}

		if (!clients_count)
			return;
		
		new Handle:hMsg = StartMessage("SayText2", clients, clients_count, 0);
		if (!hMsg)
		{
			static bool:b = false;
			if (!b)
			{
				b = true;
				LogError("SayText2 error");
			}
			return;
		}
		BfWriteByte  (hMsg, client);
		BfWriteByte  (hMsg, true);
		BfWriteString(hMsg, message);
		EndMessage();
	}
}

static send_msg(client, const String:message[], team = 0)
{
	new bool:bAuthorAlive  = IsPlayerAlive(client);
	new bool:bCanSendToAll = g_iChatAllFlag && (GetUserFlagBits(client) & g_iChatAllFlag);
	
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && (!team || team == GetClientTeam(i)) && (bCanSendToAll || CanSendMsg(bAuthorAlive, i)))
			PrintToChat(i, message);
	}
}

// 0 = сообщения видны всем
// 1 = сообщения мертвых видят только мертвые + мертвые могут видеть сообщения живых
// 2 = сообщения мертвых видят только мертвые + мертвые не могут видеть сообщения живых

static bool:CanSendMsg(bool:bAuthorAlive, target)
{
	if (!g_iChatDeath)
		return true;
	
	if (g_iChatDeath == 1)
		return bAuthorAlive || !IsPlayerAlive(target);
	
	return bAuthorAlive == IsPlayerAlive(target);
}